#include <iostream.h>
#include "mapsim.h"
#include <new.h>
#include <deque.h>

Maps::Maps(int n)
{
  npix = n;
}

Maps::~Maps()
{
  t.clear();
  q.clear();
  u.clear();
}

double Maps::getT(int i) const {return t.at(i);}
double Maps::getQ(int i) const {return q.at(i);}
double Maps::getU(int i) const {return u.at(i);}

void Maps::setT(double d) {t.push_back(d);}
void Maps::setQ(double d) {q.push_back(d);}
void Maps::setU(double d) {u.push_back(d);}

void Maps::setNpix()
{
  if(t.size() != q.size() || t.size() != u.size()){
    cerr << "error: size of maps do not match ..."<<endl;
    return;
  }
  npix = t.size();
}

int Maps::getNpix() const {return npix;}
