/* 
   Header file for mapsim v0.1 

   This file contains various defintions and fucntion
   prototypes.
*/

/* place definitions here */

#ifndef HEADER
#define HEADER

#include <vector.h>
#include <deque.h>

using namespace std;

#define LMAX 1500
#define PI 3.14159265
#define PRINT  /* remove this defintion to PREVENT printing progress 
		  to screen */

void   rdtoxyz(double[],double[],double[],double[],double[],int);
void   trig(double,double,double[],double[],int);
void   M_gen(double,double **,int);
void   Y_gen(double **,double **,double **,double *,double *,int);
void   W_gen(double,double**,double**,int);
void   X_gen(double,double**,double**,int);
float  gasdev(long *);
float  ran1(long *);
double det(double **);
void   choldc(double **, int ,double []);


// class Pixels 

class Pixels {
  
 public:
  Pixels(int = 0);
  bool read_pixels();
  void setxyz();
  void setNpix(int);
  int  getNpix() const;
  double getx(int) const; 
  double gety(int) const;
  double getz(int) const;
  
 private:
  int npix;
  vector<double> ra;
  vector<double> dec;
  vector<double> x;
  vector<double> y;
  vector<double> z;
  
};

// class maps
class Maps {
  
 public:
  Maps(int = 0);
  ~Maps();
  void setT(double);
  void setQ(double);
  void setU(double);
  double getT(int) const; 
  double getQ(int) const;
  double getU(int) const;

  int getNpix() const;
  void setNpix();

 private:
  int npix;
  deque<double> t;
  deque<double> q;
  deque<double> u;

};

// class maps
class Models {
  
 public:
  Models(int = 0);
  bool read_models();
  double getTT(int) const; 
  double getEE(int) const;
  double getBB(int) const;
  double getTE(int) const;
  double getTB(int) const;
  double getEB(int) const;
  int getlmax()  const;

 private:
  int lmax;
  vector<double> tt;
  vector<double> ee;
  vector<double> bb;
  vector<double> te;
  vector<double> eb;
  vector<double> tb;
};

#endif


