#include <iostream.h>
#include <fstream.h>
#include "mapsim.h"
#include <new.h>

Models::Models(int n)
{
  lmax = n;
}

// return true of successful
bool Models::read_models()
{
  FILE *pt;
  ifstream fin;
  ifstream fwint;
  ifstream fwine;
  ifstream fwinb;
  
  char filename[80];
  int i;
  
  double *wt;
  double *we;
  double *wb;
 
  double di;
  double tt_tmp;
  double ee_tmp;
  double bb_tmp;
  double te_tmp;
  double tb_tmp;
  double eb_tmp;
  
  cout << "Enter models filename: ";
  cin  >> filename;
  
  fin.open(filename,ios::in);
  if(!fin){
    cout << "Error: no file by that name, try again ..."<<endl;
    return false;}
  
  tt.push_back(0.0);
  te.push_back(0.0);
  tb.push_back(0.0);
  ee.push_back(0.0);
  bb.push_back(0.0);
  eb.push_back(0.0);
  tt.push_back(0.0);
  te.push_back(0.0);
  tb.push_back(0.0);
  ee.push_back(0.0);
  bb.push_back(0.0);
  eb.push_back(0.0);
        
  i=2;
  while(fin>>tt_tmp>>te_tmp>>tb_tmp>>ee_tmp>>bb_tmp>>eb_tmp){
    di = (double)i;
    tt.push_back(tt_tmp*2.726*2.726*1.e12*2.*PI/(di*(di+1)));
    te.push_back(te_tmp*2.726*2.726*1.e12*2.*PI/(di*(di+1)));
    tb.push_back(tb_tmp*2.726*2.726*1.e12*2.*PI/(di*(di+1)));
    ee.push_back(ee_tmp*2.726*2.726*1.e12*2.*PI/(di*(di+1)));
    bb.push_back(bb_tmp*2.726*2.726*1.e12*2.*PI/(di*(di+1)));
    eb.push_back(eb_tmp*2.726*2.726*1.e12*2.*PI/(di*(di+1))); 
    i++;
  }
  fin.close();
  lmax = i-1;
  
  cout << "Read in "<<lmax<<" spherical harmonic multipoles.\n";

  //
  // READ IN WINDOW FILES
  //
  wt = new double[lmax+1];
  we = new double[lmax+1];
  wb = new double[lmax+1];
  
  fwint.open("mwindow_t",ios::in);
  if(!fwint){
    cerr << "ERROR: no mwindow_t file" << endl;
    exit(0);}
  for(i=0 ; i<=lmax ; i++)
    fwint >> wt[i];
  fwint.close();
  
  fwine.open("mwindow_e",ios::in);
  if(!fwine){
    printf("ERROR: no e window file\n");
    exit(0);}
  for(i=0 ; i<=lmax ; i++)
    fwine >> we[i];
  fwine.close();
  
  fwinb.open("mwindow_b",ios::in);
  if(!fwinb){
    printf("ERROR: no b window file\n");
    exit(0);}
  for(i=0 ; i<=lmax ; i++)
    fwinb >> wb[i];
  fwinb.close();
  
  for(i=2 ; i<=lmax ; i++){
    tt.at(i) *= wt[i]*wt[i];
    te.at(i) *= we[i]*we[i];
    tb.at(i) *= wb[i]*wb[i];
    te.at(i) *= wt[i]*we[i];
    tb.at(i) *= wt[i]*wb[i];
    eb.at(i) *= we[i]*wb[i];
  }

  return true;
}

double Models::getTT(int i) const {return tt.at(i);}
double Models::getEE(int i) const {return ee.at(i);}
double Models::getBB(int i) const {return bb.at(i);}
double Models::getTE(int i) const {return te.at(i);}
double Models::getTB(int i) const {return tb.at(i);}
double Models::getEB(int i) const {return eb.at(i);}
int Models::getlmax() const {return lmax;}
