#include <iostream.h>
#include <fstream.h>
#include <vector>
#include "mapsim.h"
#include <new.h>

using namespace std;

Pixels::Pixels(int n)
{
  npix = n;
}

// return true of successful
bool Pixels::read_pixels()
{
  FILE *pt;
  ifstream fin;
  char filename[80];
  int i;
  double ra_tmp;
  double dec_tmp;
  
  cout << "Enter pixels filename: ";
  cin  >> filename;
  
  fin.open(filename,ios::in);
  if(!fin){
    cout << "Error: no pixel file by that name, try again ..."<<endl;
    return false;}

  i=0;
  while(fin >> ra_tmp >> dec_tmp){
    ra.push_back(  ra_tmp  );
    dec.push_back( dec_tmp );
    i++;}

  cout << "Read in "<<i<<" pixels."<<endl;
  setNpix(i);
  return true;
}

void Pixels::setxyz()
{
  int i;
  double theta;
  
  for(i=0 ; i<npix ; i++){
    theta = 90-dec.at(i);
    x.push_back(sin(theta*PI/180)*cos(ra.at(i)*PI/180));
    y.push_back(sin(theta*PI/180)*sin(ra.at(i)*PI/180));
    z.push_back(cos(theta*PI/180));}
  
  if((x.size() != y.size()) || (z.size() != x.size()) || (x.size() != npix)){
    cout << "Error, incorrect size for values in Pixels::setxyz()" << endl;
    exit(0);
  }

  return;
  
}

double Pixels::getx(int i) const {return x.at(i);}
double Pixels::gety(int i) const {return y.at(i);}
double Pixels::getz(int i) const {return z.at(i);}
int  Pixels::getNpix() const {return npix;}
void Pixels::setNpix(int n){npix = n;}
